import { FieldInfo } from 'model-util-base'
import { ConditionUtil, ConditionUtilImpl, FieldUtil, TableUtilImpl, IdType, JoinTable, SubTable } from 'model-util'
import { Container, Singleton } from 'typescript-ioc' 
import { MsMonitorMetricsTemplateItem } from '../models/index' 

import {MsMonitorMetricsMU} from './MsMonitorMetrics' 


/**
 * @author auto generate
 * @version 1.0
 * @date 2021-06-22 11:31
 */
interface MsMonitorMetricsTemplateItemCU extends ConditionUtil<MsMonitorMetricsTemplateItemCU>{
    ID:FieldUtil<MsMonitorMetricsTemplateItemCU>;
    CREATE_TIME:FieldUtil<MsMonitorMetricsTemplateItemCU>;
    UPDATE_TIME:FieldUtil<MsMonitorMetricsTemplateItemCU>;
    STATE:FieldUtil<MsMonitorMetricsTemplateItemCU>;
    TEMPLATE_ID:FieldUtil<MsMonitorMetricsTemplateItemCU>;
    METRICS_ID:FieldUtil<MsMonitorMetricsTemplateItemCU>;
    UPPER_LIMIT:FieldUtil<MsMonitorMetricsTemplateItemCU>;
    HOLD_MINUTES:FieldUtil<MsMonitorMetricsTemplateItemCU>;
    LOWER_LIMIT:FieldUtil<MsMonitorMetricsTemplateItemCU>;
    COOLING_MINUTES:FieldUtil<MsMonitorMetricsTemplateItemCU>;
}

class MsMonitorMetricsTemplateItemCUImpl extends ConditionUtilImpl<MsMonitorMetricsTemplateItemCUImpl> implements MsMonitorMetricsTemplateItemCU{ 
    newInstance(): MsMonitorMetricsTemplateItemCUImpl {
        return new MsMonitorMetricsTemplateItemCUImpl();
    } 
    get ID(): FieldUtil<MsMonitorMetricsTemplateItemCU>{  
        return new FieldUtil('id','id','id', this);
    }
    get CREATE_TIME(): FieldUtil<MsMonitorMetricsTemplateItemCU>{  
        return new FieldUtil('create_time','createTime','create_time', this);
    }
    get UPDATE_TIME(): FieldUtil<MsMonitorMetricsTemplateItemCU>{  
        return new FieldUtil('update_time','updateTime','update_time', this);
    }
    get STATE(): FieldUtil<MsMonitorMetricsTemplateItemCU>{  
        return new FieldUtil('state','state','state', this);
    }
    get TEMPLATE_ID(): FieldUtil<MsMonitorMetricsTemplateItemCU>{  
        return new FieldUtil('template_id','templateId','模板id', this);
    }
    get METRICS_ID(): FieldUtil<MsMonitorMetricsTemplateItemCU>{  
        return new FieldUtil('metrics_id','metricsId','指标id', this);
    }
    get UPPER_LIMIT(): FieldUtil<MsMonitorMetricsTemplateItemCU>{  
        return new FieldUtil('upper_limit','upperLimit','上限阈值', this);
    }
    get HOLD_MINUTES(): FieldUtil<MsMonitorMetricsTemplateItemCU>{  
        return new FieldUtil('hold_minutes','holdMinutes','保持分钟数', this);
    }
    get LOWER_LIMIT(): FieldUtil<MsMonitorMetricsTemplateItemCU>{  
        return new FieldUtil('lower_limit','lowerLimit','下限阈值', this);
    }
    get COOLING_MINUTES(): FieldUtil<MsMonitorMetricsTemplateItemCU>{  
        return new FieldUtil('cooling_minutes','coolingMinutes','冷却分钟数', this);
    }
    get METRICS_CODE(): FieldInfo{  
        return new FieldInfo('metricsCode','代码');
    }
    get METRICS_NAME(): FieldInfo{  
        return new FieldInfo('metricsName','名称');
    }
    get METRICS_UNIT_NAME(): FieldInfo{  
        return new FieldInfo('metricsUnitName','单位名称');
    }
    get PROMETHEUS_QUERY_PARAM(): FieldInfo{  
        return new FieldInfo('prometheusQueryParam','prometheus查询查询参数定义（JSON)');
    }
}

@Singleton 
class MsMonitorMetricsTemplateItemMU extends TableUtilImpl<MsMonitorMetricsTemplateItemCU,MsMonitorMetricsTemplateItem>{ 
    tableName  = 'ms_monitor_metrics_template_item';
    tableFields  = ['id','create_time','update_time','state','template_id','metrics_id','upper_limit','hold_minutes','lower_limit','cooling_minutes'];
    modelFields  = ['id','createTime','updateTime','state','templateId','metricsId','upperLimit','holdMinutes','lowerLimit','coolingMinutes','metricsCode','metricsName','metricsUnitName','prometheusQueryParam'];
    modelIdFields  = ['id'];
    tableIdFields  = ['id'];
    idType = IdType.CUSTOM;
    joinTables = [{
            joinByDefault: true,
            foreignKeyFields: [MsMonitorMetricsTemplateItemMU.METRICS_ID],
            joinIdFields: [MsMonitorMetricsMU.ID],
            getTableUtil: ()=>{
                return Container.get(MsMonitorMetricsMU);
            },
            fields: [
                {
                    fieldUtil: MsMonitorMetricsMU.CODE,
                    alias: 'metricsCode'
                }
                ,{
                    fieldUtil: MsMonitorMetricsMU.NAME,
                    alias: 'metricsName'
                }
                ,{
                    fieldUtil: MsMonitorMetricsMU.UNIT_NAME,
                    alias: 'metricsUnitName'
                }
                ,{
                    fieldUtil: MsMonitorMetricsMU.PROMETHEUS_QUERY_PARAM,
                    alias: 'prometheusQueryParam'
                }
            ]

        } as JoinTable

];
    subTables = [];

    createConditionUtil(): MsMonitorMetricsTemplateItemCU {
        return new MsMonitorMetricsTemplateItemCUImpl();
    }   

    static get ID(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return new FieldUtil('id','id','id', new MsMonitorMetricsTemplateItemCUImpl());
    }
    static get CREATE_TIME(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return new FieldUtil('create_time','createTime','create_time', new MsMonitorMetricsTemplateItemCUImpl());
    }
    static get UPDATE_TIME(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return new FieldUtil('update_time','updateTime','update_time', new MsMonitorMetricsTemplateItemCUImpl());
    }
    static get STATE(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return new FieldUtil('state','state','state', new MsMonitorMetricsTemplateItemCUImpl());
    }
    static get TEMPLATE_ID(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return new FieldUtil('template_id','templateId','模板id', new MsMonitorMetricsTemplateItemCUImpl());
    }
    static get METRICS_ID(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return new FieldUtil('metrics_id','metricsId','指标id', new MsMonitorMetricsTemplateItemCUImpl());
    }
    static get UPPER_LIMIT(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return new FieldUtil('upper_limit','upperLimit','上限阈值', new MsMonitorMetricsTemplateItemCUImpl());
    }
    static get HOLD_MINUTES(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return new FieldUtil('hold_minutes','holdMinutes','保持分钟数', new MsMonitorMetricsTemplateItemCUImpl());
    }
    static get LOWER_LIMIT(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return new FieldUtil('lower_limit','lowerLimit','下限阈值', new MsMonitorMetricsTemplateItemCUImpl());
    }
    static get COOLING_MINUTES(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return new FieldUtil('cooling_minutes','coolingMinutes','冷却分钟数', new MsMonitorMetricsTemplateItemCUImpl());
    }
    static get METRICS_CODE(): FieldInfo{  
        return new FieldInfo('metricsCode','代码');
    }
    static get METRICS_NAME(): FieldInfo{  
        return new FieldInfo('metricsName','名称');
    }
    static get METRICS_UNIT_NAME(): FieldInfo{  
        return new FieldInfo('metricsUnitName','单位名称');
    }
    static get PROMETHEUS_QUERY_PARAM(): FieldInfo{  
        return new FieldInfo('prometheusQueryParam','prometheus查询查询参数定义（JSON)');
    }

    get ID(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return MsMonitorMetricsTemplateItemMU.ID;
    }
    get CREATE_TIME(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return MsMonitorMetricsTemplateItemMU.CREATE_TIME;
    }
    get UPDATE_TIME(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return MsMonitorMetricsTemplateItemMU.UPDATE_TIME;
    }
    get STATE(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return MsMonitorMetricsTemplateItemMU.STATE;
    }
    get TEMPLATE_ID(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return MsMonitorMetricsTemplateItemMU.TEMPLATE_ID;
    }
    get METRICS_ID(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return MsMonitorMetricsTemplateItemMU.METRICS_ID;
    }
    get UPPER_LIMIT(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return MsMonitorMetricsTemplateItemMU.UPPER_LIMIT;
    }
    get HOLD_MINUTES(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return MsMonitorMetricsTemplateItemMU.HOLD_MINUTES;
    }
    get LOWER_LIMIT(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return MsMonitorMetricsTemplateItemMU.LOWER_LIMIT;
    }
    get COOLING_MINUTES(): FieldUtil<MsMonitorMetricsTemplateItemCU>{ 
        return MsMonitorMetricsTemplateItemMU.COOLING_MINUTES;
    }
    get METRICS_CODE(): FieldInfo{  
        return MsMonitorMetricsTemplateItemMU.METRICS_CODE;
    }
    get METRICS_NAME(): FieldInfo{  
        return MsMonitorMetricsTemplateItemMU.METRICS_NAME;
    }
    get METRICS_UNIT_NAME(): FieldInfo{  
        return MsMonitorMetricsTemplateItemMU.METRICS_UNIT_NAME;
    }
    get PROMETHEUS_QUERY_PARAM(): FieldInfo{  
        return MsMonitorMetricsTemplateItemMU.PROMETHEUS_QUERY_PARAM;
    }
}
export {MsMonitorMetricsTemplateItemMU, MsMonitorMetricsTemplateItemCU}
